# Gpr

Gitkeeper - Pluggable Repository Manager.

## Description

Gpr provides a simple management of the git repository.

Behave like a `go get` of Golang.

For example, all repositories are cloned to `$HOME/.gpr/<host>/<user>/<repository>`.

It is possible to centrally manage of the all repositories, and extend the function using [plugins](https://github.com/search?utf8=✓&q=user%3Akaihar4+gpr%5C&type=Repositories&ref=searchresults).

## Installation

Install as minimal.

```sh
$ gem install gpr
```

Or, extend the function using [plugins](https://github.com/search?utf8=✓&q=user%3Akaihar4+gpr%5C&type=Repositories&ref=searchresults).

```sh
$ cd /usr/local/bin
$ bundle init
$ vi Gemfile
source 'https://rubygems.org'

gem 'gpr'
gem 'gpr-select'
gem 'gpr-search'
gem 'gpr-status'
$ bundle install --path vendor/bundle --binstubs ./
```

## Requirements

* Ruby 2.1.0 or higher

## Usage

```sh
$ gpr help
```

### Register a git repository into Gpr directory

Just clone a git repository into `$HOME/.gpr/<host>/<user>/<repository>`.

```sh
# e.g. gpr get git@github.com:kaihar4/gpr.git
$ gpr get <repository url>
```

### Show all registered repositories

```sh
Usage:
  gpr list

Options:
  [--paths], [--no-paths]  # Show the paths of all registered repositories

Show all registered repositories
```

## Configuration

### Change the directory to be cloned

```sh
$ export GPR_ROOT=$HOME/develop
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release` to create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

1. Fork it ( https://github.com/kaihar4/gpr/fork )
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new Pull Request
